import api.ResponseHandler;
import com.sun.net.httpserver.HttpServer;
import model.personnality.Trait;
import model.questionnaire.Answer;
import model.questionnaire.Question;
import model.questionnaire.Questionnaire;

import java.net.InetSocketAddress;
import java.util.Arrays;

public class Application {

    public static void main(String [] args)
    {

        Questionnaire vQuestionnaire = getQuestionnaire();
        //------------------------------------
        // Start server
        //------------------------------------
        try {
            HttpServer vServer = HttpServer.create(new InetSocketAddress(8080), 0);
            vServer.createContext("/", new ResponseHandler());
            vServer.setExecutor(null);
            vServer.start();
        }
        catch(Exception ve)
        {
            ve.printStackTrace();
        }
    }

    public static Questionnaire getQuestionnaire()
    {
        Trait vExtrovertTrait = new Trait("Extrovert", "You're an extrovert.");
        Trait vIntrovertTrait = new Trait("Introvert", "You're an introvert.");
        Trait vDogTrait = new Trait("Dog", "You're a dog that appears to know how to read.");

        //------------------------------------
        // Define questionnaire
        //------------------------------------
        return new Questionnaire(
                "Introvert or extrovert ?",
                Arrays.asList(
                        //------------------------------------
                        // First question
                        //------------------------------------
                        new Question(
                                "You're really busy at work and a colleague is telling you their life story and personal woes, you :",
                                Arrays.asList(
                                        new Answer("Don't dare to interrupt them", vIntrovertTrait, 0.5f),
                                        new Answer("Think it's more important to give them some of your time; work can wait", vExtrovertTrait, 0.2f),
                                        new Answer("Listen, but with only with half an ear ", vIntrovertTrait, 0.2f),
                                        new Answer("Try to show interest despite being busy chasing your tail", vDogTrait, 0.8f),
                                        new Answer("Interrupt and explain that you are really busy at the moment", vExtrovertTrait, 0.5f)
                                )
                        ),
                        //------------------------------------
                        // Second question
                        //------------------------------------
                        new Question(
                                "You've been sitting in the doctor's waiting room for more than 25 minutes, you :",
                                Arrays.asList(
                                        new Answer("Look at your watch every two minutes", vIntrovertTrait, 0.2f),
                                        new Answer("Bubble with inner anger, but keep quiet ", vIntrovertTrait, 0.5f),
                                        new Answer("Explain to other equally impatient people in the room that the doctor is always running late ", vExtrovertTrait, 0.3f),
                                        new Answer("Complain in a loud voice, while tapping your foot impatiently", vExtrovertTrait, 0.7f),
                                        new Answer("Befriend the teckel sitting next to you", vDogTrait, 0.7f)
                                )
                        ),
                        //------------------------------------
                        // Third question
                        //------------------------------------
                        new Question(
                                "How do you usually answer affirmatively ?",
                                Arrays.asList(
                                        new Answer("Yes.", vIntrovertTrait, 0.2f),
                                        new Answer("Woof", vDogTrait, 0.7f),
                                        new Answer("Absolutely !", vExtrovertTrait, 0.3f)
                                )
                        ),
                        //------------------------------------
                        // Fourth question
                        //------------------------------------
                        new Question(
                                "When receiving guests, you don't appreciate :",
                                Arrays.asList(
                                        new Answer("People that don't feed the conversation.", vExtrovertTrait, 0.2f),
                                        new Answer("Cats.", vDogTrait, 0.7f),
                                        new Answer("Being the center of attention.", vIntrovertTrait, 0.3f)
                                )
                        ),
                        //------------------------------------
                        // Fifth question
                        //------------------------------------
                        new Question(
                                "You can't find the keys to your car.",
                                Arrays.asList(
                                        new Answer("You search desperately without asking for help", vIntrovertTrait, 0.2f),
                                        new Answer("You get everyone here to look with you.", vExtrovertTrait, 0.2f),
                                        new Answer("You don't need to worry about car keys because you can't drive a car with your paws.", vDogTrait, 0.7f)

                                )
                        )
                )
        );
    }

}
