package model.questionnaire;

import com.github.cliftonlabs.json_simple.JsonObject;

import java.util.ArrayList;
import java.util.List;

import static api.JsonKeys.KEY_NAME;
import static api.JsonKeys.KEY_QUESTIONS;

public class Questionnaire{

    private static final List<Questionnaire> sQuestionnaires = new ArrayList<>();
    private final List<Question> fQuestions;
    private final String fName;

    public Questionnaire(String iName, List<Question> iQuestions)
    {
        fName = iName;
        fQuestions = iQuestions;
        sQuestionnaires.add(this);
    }

    // quick and dirty for now
    public static Questionnaire getTheOnlyExistingQuestionnaire(){
        return sQuestionnaires.stream().findFirst().get();
    }

    public JsonObject asJsonObject(){
        JsonObject vResult = new JsonObject();
        vResult.put(KEY_NAME, fName);
        vResult.put(KEY_QUESTIONS,fQuestions);
        return vResult;
    }
}
