package api;

import com.github.cliftonlabs.json_simple.JsonObject;
import controller.ModelController;
import controller.SessionController;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;


class ResponseHandlerTest {

    @Test
    public void TestGetResponse(){
        ResponseHandler vResponseHandler = new ResponseHandler();

        String [] vPath = {};
        JsonObject vErrorObject = new JsonObject();

        vErrorObject.put("error", "Method 'CAFE' not implemented");
        assertEquals(vErrorObject, vResponseHandler.getResponse("CAFE", vPath, "Yo", null));

        vErrorObject.put("error", "DELETE with 0 subdirectories not implemented");
        assertEquals(vErrorObject, vResponseHandler.getResponse("DELETE", vPath, "Yo", null));

        vPath = new String[]{"elo", "elo"};
        vErrorObject.put("error", "DELETE with 2 subdirectories not implemented");
        assertEquals(vErrorObject, vResponseHandler.getResponse("DELETE", vPath, "Yo", null));

        //Get a valid session id
        SessionController vSessionController = new SessionController();
        JsonObject vSessionObject = vResponseHandler.getResponse("GET",new String[]{},"", vSessionController);
        assertTrue(vSessionObject.containsKey("id"));
        String vSessionId = (String) vSessionObject.get("id");

        //Verify error management in various cases
        String[] vPathSession = new String[]{vSessionId};
        JsonObject vResponseObject;
        Object[][] vTestCases = new Object[][]{
                {"PUT", vPathSession, "Yo", vSessionController},
                {"PUT", new String[]{"a"}, "{}", vSessionController},
                {"PUT", new String[]{"ff95a8b5-736a-4198-acaa-1fecdaa94c14"}, "{}", vSessionController},
                {"PUT", vPathSession, "{\"question\":\"a\",\"answer\":\"a\"}", vSessionController},
                {"PUT", vPathSession, "{\"question\":\"ff95a8b5-736a-4198-acaa-1fecdaa94c14\",\"answer\":\"ff95a8b5-736a-4198-acaa-1fecdaa94c14\"}", vSessionController},
        };
        for(Object [] vTestCase : vTestCases)
        {
            vResponseObject = vResponseHandler.getResponse((String) vTestCase[0],(String[]) vTestCase[1],(String) vTestCase[2],(ModelController) vTestCase[3]);
            assertTrue(vResponseObject.containsKey("error"));
            assertNotEquals(null, vResponseObject.get("error"));
        }


    }
}